extproc perl.exe -Sx
#!perl -s
#
# FileName:  sperl002.cmd
#
# Type:  PERL Code Sample
#                 
# Called by:  sperl002.mac                   
#
# Description:  This program receives 3 arguments and 2 parameters from
#               the caller and prints a description and their values to
#               standard out.  It also uses DTWPIPE to change the value
#               of PARAMETER2 to the current value of PARAMETER1.  It 
#               then uses DTWPIPE to create a table with 2 rows and 3 
#               columns that has column headers and contains the values
#               of the arguements and parameters that were passed in.
#
#                  ------------------------------------
#
# Licensed Materials - Property of IBM
#
# (C) COPYRIGHT International Business Machines Corp. 1996
# All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#                  ------------------------------------
#
#               NOTICE TO USERS OF THE SOURCE CODE EXAMPLES
#
#  INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE
#  EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, "AS IS" WITHOUT
#  WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT
#  LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
#  PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE
#  OF THE SOURCE CODE EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS,
#  IS WITH YOU.  SHOULD ANY PART OF THE SOURCE CODE EXAMPLES PROVE
#  DEFECTIVE, YOU (AND NOT IBM) ASSUME THE ENTIRE COST IF ALL NECESSARY
#  SERVICING, REPAIR OR CORRECTION.
#
                    
#
# Open the pipe.  The $ENV reference to DTWPIPE is used to
# retrieve the name of the pipe from the environment variable
# DTWPIPE. 
#
$a = $ENV{DTWPIPE};
open(DTW,"> $a");

#
# These print statements send data to standard out.  The $ENV 
# references are used to retrieve values of environment variables.
#
print "<em>... sperl002.cmd begins ...</em>\n\n";
print "Input arguments\n";
print "Argument 1 is: $a1\n";
print "Argument 2 is: $a2\n";
print "Argument 3 is: $a3\n\n\n";
print "Input parameters<br>";
print "Parameter 1 = $ENV{PARAMETER1}\n";
print "Parameter 2 = $ENV{PARAMETER2}\n\n";

#
# These print statements cause the data to go to the pipe.  They
# are used to set the value of environment variables.
#
print DTW "table_ROWS=\"2\" ";
print DTW "table_COLS=\"3\" ";
print DTW "table_N_1=\"COL1\" ";
print DTW "table_N_2=\"COL2\" ";
print DTW "table_N_3=\"COL3\" ";
print DTW "table_V_1_1=\"$a1\" ";
print DTW "table_V_1_2=\"$a2\" ";
print DTW "table_V_1_3=\"$a3\" ";
print DTW "table_V_2_1=\"$ENV{PARAMETER1}\" ";
print DTW "table_V_2_2=\"$ENV{PARAMETER2}\" ";
print DTW "parameter2=\"$ENV{PARAMETER1}\" ";

#
# This print statement sends data to standard out.
#
print "<em>... sperl002.cmd completes ...</em>\n\n";

#
# Close the pipe
#
$a = $ENV{DTWPIPE};
open(DTW,"> $a");
close(DTW);
