/******************************************************************************/
/*   FileName: srexx002.cmd                                                   */
/*                                                                            */
/*   Description:                                                             */
/*     This REXX program is used by srexx002.mac to show how to pass and      */
/*     handle variables when using a REXX function                            */
/*                                                                            */
/*                    ------------------------------------                    */
/*                                                                            */
/*   Licensed Materials - Property of IBM                                     */
/*                                                                            */
/*   (C) COPYRIGHT International Business Machines Corp. 1996                 */
/*    All Rights Reserved.                                                    */
/*                                                                            */
/*   US Government Users Restricted Rights - Use, duplication or              */
/*   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.        */
/*                                                                            */
/*                    ------------------------------------                    */
/*                                                                            */
/*               NOTICE TO USERS OF THE SOURCE CODE EXAMPLES                  */
/*                                                                            */
/*  INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE      */
/*  EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, "AS IS" WITHOUT    */
/*  WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT     */
/*  LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A    */
/*  PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE    */
/*  OF THE SOURCE CODE EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, */
/*  IS WITH YOU.  SHOULD ANY PART OF THE SOURCE CODE EXAMPLES PROVE           */
/*  DEFECTIVE, YOU (AND NOT IBM) ASSUME THE ENTIRE COST IF ALL NECESSARY      */
/*  SERVICING, REPAIR OR CORRECTION.                                          */
/*                                                                            */
/******************************************************************************/

SAY "<em>... srexx002.cmd begins ...</em>"
SAY ""

/* get the arguments */
SAY "Input arguments"
PARSE ARG A1 A2 A3

/* show argument values */
SAY "Argument 1 is:" A1
SAY "Argument 2 is:" A2
SAY "Argument 3 is:" A3
SAY ""

/* show parameter values */
SAY "Input parameters"
SAY "Parameter 1 =" parameter1
SAY "Parameter 2 =" parameter2

/* set up number of rows and columns */
table_ROWS=2
table_COLS=3

/* assign column names */
table_N.1 = COL1
table_N.2 = COL2
table_N.3 = COL3

/* assign values to table cells */
table_V.1.1 = A1
table_V.1.2 = A2
table_V.1.3 = A3
table_V.2.1 = parameter1
table_V.2.2 = parameter2
parameter2 = parameter1
SAY ""
SAY "<em>... srexx002.cmd completes ...</em>"
SAY ""

