//=======================================================================
// File   : ChartUI.java    
// Author : Jian Liang (jian.liang@ebay.sun.com)
// Date   : 1/30/96
// Version: 1.0 ( for Beta2 JDK API)
//
// All Right Reserved. 
//
// applet to create chart. User Interface is created if parameters 
// not provided.
//
//=======================================================================

import java.awt.*;
import java.applet.Applet;
import java.io.*;
import java.lang.*;

public class ChartUI2 extends Applet 
{    
   private AllChart2  m_ChartCanvas = null;
   private Choice     m_ChartType = null;

   float values[][];

   private String  ChartTitle;
   private int     depth,width;
   private int     NumofPoints;
   private int     NumofCols;
   private int     AppVersion ;


	// ============ Get parameter of the applet ================
	public String getAppletParmS(String name, String DefValue){
	   String at = getParameter(name);
	   return (at != null) ? at : DefValue;
	}

	public  int getAppletParmI(String name, String DefValue){
	   String at = getParameter(name);
	   return Integer.valueOf( (at != null) ? at : DefValue).intValue();
	}

	public  float getAppletParmF(String name, String DefValue){
	   String at = getParameter(name);
	   return Float.valueOf( (at != null) ? at : DefValue).floatValue();
	}

        public  float[] getAppletTableF(int Lnumrow)
        { 
          float[] values=new float[Lnumrow];
          for (int i = 0; i < Lnumrow; i++)
	    values[i] = getAppletParmF("DTW_" + (i+1) + "_name","0.0");
          return values;  
        }


   //------------------------------------------------------------------------
   // METHOD: init
   //       overwrite Applet.init()
   // PARAMETERS: none.
   // RETURN:  none.
   //------------------------------------------------------------------------   
   public void init()
   {
      setLayout(new BorderLayout(2,2));
      
      // upper static panel 
      Panel p0 = new Panel();            
      m_ChartType = new Choice();      
      m_ChartType.addItem("Horizontal Bar");
      m_ChartType.addItem("Line");
      m_ChartType.addItem("Vertical Bar");
      m_ChartType.addItem("Pie");            
      m_ChartType.addItem("3D Horizontal Bar");
      m_ChartType.addItem("3D Vertical Bar");
      m_ChartType.addItem("3D Pie");
      p0.add(new Label("Chart Type:", Label.RIGHT));      
      p0.add(m_ChartType);
      
      /* p0.add(new Button("New Chart"));       */
      add("North", p0 );

      String ColName;
      String TableTitle = getAppletParmS("DTW_TABLE_1_NAME", "");
      width       = getAppletParmI("ChartUI2.width","100");
      depth       = getAppletParmI("ChartUI.height","20");
      NumofPoints = getAppletParmI("DTW_" + TableTitle + "_NUMBER_OF_ROWS","0");   
      NumofCols   = getAppletParmI("DTW_" + TableTitle + "_NUMBER_OF_COLUMNS","0");   
      AppVersion  = (NumofCols == 0) ? 0 : 1; 
      if (NumofCols ==0) NumofCols = 1;
      ChartTitle  = getAppletParmS("ChartTitle","");

      m_ChartType.select(getAppletParmS("ChartType","Line"));

      values = new float[NumofCols][NumofPoints];

      if (AppVersion == 0)
      {
        for (int i = 0; i < NumofPoints; i++){
            ColName = getAppletParmS("DTW_" + TableTitle + "_COLUMN_NAME_2", "");
	    values[0][i] = getAppletParmF("DTW_" + TableTitle + "_" + ColName + "_VALUE_" + (i+1),"0.0");
      }}
      else 
      {
         for (int c=0; c<NumofCols; c++)
           for (int i = 0; i < NumofPoints; i++){
              ColName = getAppletParmS("DTW_" + TableTitle + "_COLUMN_NAME_" + (c+2), "");
	      values[c][i] = getAppletParmF("DTW_" + TableTitle + "_" + ColName + "_VALUE_" + (i+1) ,"0.0");
           }}
      createNewChart(width,depth,NumofPoints,NumofCols,values,ChartTitle);
   } 
   
   //------------------------------------------------------------------------
   // METHOD: action
   //
   //       overwrite Component.action(...)
   //
   // PARAMETERS: evt - the event 
   //             arg - the action that's occuring 
   //
   // RETURN:  see manual.
   //------------------------------------------------------------------------   
   public boolean action(Event evt, Object arg)
   {
     /*****
     if (evt.target instanceof Button)
     {
        Button b = (Button)evt.target;
        if ( b.getLabel() == "New Chart" ) 
             createNewChart(width,depth,NumofPoints,values,ChartTitle);

        return true;
     }
     ******/
     if (evt.target instanceof Choice)
     {
        createNewChart(width,depth,NumofPoints,NumofCols,values,ChartTitle);
        return true;
     }
     return false;
   }
   

   //------------------------------------------------------------------------
   // METHOD: createNewChart
   //
   //       create a new chart in proper type.
   //
   // PARAMETERS: none.
   //
   // RETURN:  none.
   //------------------------------------------------------------------------   
   public  void createNewChart(int depth,int radius, int numRow,int numCol,float[][] values, String ChartTitle)
   {
      String chartType = m_ChartType.getSelectedItem();
      
      if ( m_ChartCanvas != null )            { remove(m_ChartCanvas);           }
            
      if (chartType.equals("Horizontal Bar")) 
          { m_ChartCanvas = new HBarChart(); }
      else 
      if ( chartType.equals("Vertical Bar") )
          { m_ChartCanvas = new VBarChart(); }
      else
      if ( chartType.equals("Line") )         
          { m_ChartCanvas = new LineChart(); }
      else 
      if ( chartType.equals("Pie") )          
          { m_ChartCanvas = new PieChart();  }
      else
      if ( chartType.equals("3D Pie") )       
          { m_ChartCanvas = new ThreeDPieChart(); }
      else 
      if ( chartType.equals("3D Horizontal Bar") )
          { m_ChartCanvas = new ThreeDHBarChart(); }
      else 
      if ( chartType.equals("3D Vertical Bar") )  
          { m_ChartCanvas = new ThreeDVBarChart(); }
      else 
      return;
       
      add("Center", m_ChartCanvas );      
      m_ChartCanvas.initChart(depth,radius, numRow,numCol,values,ChartTitle);
      validate();
   }   
  
}

