// package dtw_aplt;

import java.applet.*;

public class DTW_Applet extends Applet
    {
    public void init()
        {
        ntables = Integer.parseInt(getParameter("DTW_NUMBER_OF_TABLES"));

        if (ntables > 0)
            {
            tbl_list = new String[ntables];

            for (int i = 0; i < ntables; i++)
                tbl_list[i] = getParameter("DTW_TABLE_"+ (i+1) +"_NAME");
            }
        }

    public int GetNumberOfTables()
        {
        return (ntables);
        }

    public String [] GetTableNames()
        {
        return (tbl_list);
        }

    public int GetNumberOfColumns(String table_name)
        {
        return (Integer.parseInt(getParameter("DTW_"+table_name+"_NUMBER_OF_COLUMNS")));
        }

    public int GetNumberOfRows(String table_name)
        {
        return (Integer.parseInt(getParameter("DTW_"+table_name+"_NUMBER_OF_ROWS")));
        }

    public String[] GetColumnNames(String table_name)
        {
        int ncols = GetNumberOfColumns(table_name);
        String [] column_names = new String[ncols];

        for (int i = 0; i < ncols; i++)
             column_names[i] = getParameter("DTW_"+table_name+"_COLUMN_NAME_"+(i+1));

        return (column_names);
        }

    public String[][] GetTable(String table_name)
        {
        int nrows = GetNumberOfRows(table_name);
        int ncols = GetNumberOfColumns(table_name);
        String [] column_names = new String[ncols];

        for (int i = 0; i < ncols; i++)
             column_names[i] = getParameter("DTW_"+table_name+"_COLUMN_NAME_"+(i+1));

        String [][] table_matrix = new String[ncols][nrows];

        for (int i = 0; i < ncols; i++)
            {
            for (int j = 0; j < nrows; j++)
                {
                table_matrix[i][j] = getParameter("DTW_"+table_name+"_"+
                                                  column_names[i]+"_VALUE_"+(j+1));
                }
            }
        return (table_matrix);
        }
//
// Data member for the DTW_Applet class.
//
    private int ntables;
    private String [] tbl_list;
    }
