//  lineChart.class    b1   3/20/97   Jacob Gray, IBM


import java.awt.*;
import java.lang.*;
import java.io.*;

public class myChart extends DTW_Applet {

  int values[][];
  int max = 0;
  int tableNum;
  String tableNames[];
  int columnNum;
  int rowNum;
  String columnNames[];
  String tableValues[][];
  Object colors[];
  Object colorBank[];

  public synchronized void init() {

    super.init();

    tableNum = GetNumberOfTables();
    
    tableNames = new String[tableNum];
    tableNames = GetTableNames();
    
    columnNum = GetNumberOfColumns(tableNames[0]);
    
    rowNum = GetNumberOfRows(tableNames[0]);
    
    columnNames = new String[columnNum];
    columnNames = GetColumnNames(tableNames[0]);
    
    tableValues = new String[columnNum][rowNum];
    tableValues = GetTable(tableNames[0]);

    
    // move tableValues to values and change to integers
    values = new int[columnNum - 1][rowNum];
    for (int i=1; i < columnNum; i++) {  //start at 1 to avoid years
      for (int j=0; j < rowNum; j++) {
        try {
          values[i - 1][j] = Integer.parseInt(tableValues[i][j]);
        }
        catch (NumberFormatException e) {
          values[i - 1][j] = 0;
        }
        if (values[i - 1][j] > max)
          max = values[i - 1][j];
      }
    }


    // Create color array to use as line colors
    colorBank = new Color[10];
    colorBank[0] = Color.cyan;
    colorBank[1] = Color.green;
    colorBank[2] = Color.blue;
    colorBank[3] = Color.pink;
    colorBank[4] = Color.darkGray;
    colorBank[5] = Color.magenta;
    colorBank[6] = Color.red;
    colorBank[7] = Color.black;
    colorBank[8] = Color.yellow;
    colorBank[9] = Color.orange;

    // Pass the ColorBank to colors
    colors = new Color[columnNum - 1];
    for (int i=0; i < (columnNum - 1); i++) {
      colors[i] = colorBank[i % 10];
    }
  }

  
  public synchronized void paint (Graphics g) {

    int cx=0, cy=0, lx=0, ly=0;
    int spacing = 0;
    int scale = 0;
    int size = 0;
    int h=0, w=0;
    Font lableFont;
    FontMetrics lableFontMetrics;

    // setup enviornment
    h = size().height - 10;
    w = size().width - 10;
    scale = h / max;
    spacing = w / (rowNum + 1);

    // draw grid
    g.setColor(Color.white);
    g.fillRect(0, 0, size().width, size().height);
    
    g.setColor(Color.black);
    lx = cx = 5;
    cy = h + 5;
    ly = 5;
    g.drawLine(lx, ly, cx, cy);

    ly = cy;
    cx += w;
    g.drawLine(lx, ly, cx, cy);

    // draw graph lables
    cy = h;
    lx = 5;
    lableFont = new Font("Courier", Font.PLAIN, 14);
    lableFontMetrics = getFontMetrics(lableFont);
    g.setFont(lableFont);
    for (int i=0; i < rowNum; i++) {
      lx += spacing;
      cx = lx - ((lableFontMetrics.stringWidth(tableValues[0][i])) / 2);
      g.drawString(tableValues[0][i], cx, cy);
    }

    cx = 10;
    cy = h + 8;
    for (int i=1; i < (max + 1); i++) {
      cy -= scale;
      g.drawString(Integer.toString(i), cx, cy);
    }

    // draw legend
    lx = size().width;
    ly = size().height / 2;
    size = lableFontMetrics.getHeight();
    cy = ly - ((size + 1) * (columnNum -1)) / 2;
    for (int i=0; i < columnNum - 1; i++) {
      g.setColor((Color) (colors[i]));
      cx = lx - lableFontMetrics.stringWidth(columnNames[i + 1]) - 2;
      g.drawString(columnNames[i + 1], cx, cy);
      cy += size + 1;
    }
    
    

    // draw line graph for each column
    for (int i=0; i < columnNum - 1; i++) {
      g.setColor((Color) (colors[i]));
      for (int j=0; j < rowNum; j++) {
        if (j == 0) {
          ly = cy = h + 5 - (scale * values[i][j]);
          lx = cx = 5 + spacing;
        }
        else {
          cx += spacing;
          cy = h + 5 - (scale * values[i][j]);
          g.drawLine(lx, ly, cx, cy);
          g.drawLine(lx, ly + 1, cx, cy + 1);
          lx = cx;
          ly = cy;
        }
      }
    }
          
  }

  
}
